#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc8'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 8)
__CHEETAH_genTime__ = 1192883107.2568331
__CHEETAH_genTimestamp__ = 'Sat Oct 20 08:25:07 2007'
__CHEETAH_src__ = 'functions.tmpl'
__CHEETAH_srcLastModified__ = 'Sat Oct 20 07:34:59 2007'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class functions(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        Template.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def cdromList(self, cdroms, default="", **KWS):



        ## CHEETAH: generated from #def cdromList($cdroms, $default="") at line 1, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<select name="cdrom">
  <option ''')
        if VFFSL(SL,"default",True) : # generated from line 4, col 1
            _v =  '' 
            if _v is not None: write(_filter(_v))
        else:
            _v =  'selected'
            if _v is not None: write(_filter(_v))
        write(''' value="">None</option>
''')
        for cdrom in VFFSL(SL,"cdroms",True): # generated from line 6, col 3
            write('''  <option ''')
            if VFFSL(SL,"default",True) == VFFSL(SL,"cdrom.cdrom_id",True) : # generated from line 8, col 1
                _v =  'selected' 
                if _v is not None: write(_filter(_v))
            else:
                _v =  ''
                if _v is not None: write(_filter(_v))
            write(''' value="''')
            _v = VFFSL(SL,"cdrom.cdrom_id",True) # '$cdrom.cdrom_id' on line 9, col 9
            if _v is not None: write(_filter(_v, rawExpr='$cdrom.cdrom_id')) # from line 9, col 9.
            write('''">
    ''')
            _v = VFFSL(SL,"cdrom.description",True) # '$cdrom.description' on line 10, col 5
            if _v is not None: write(_filter(_v, rawExpr='$cdrom.description')) # from line 10, col 5.
            write('''
  </option>
''')
        write('''</select>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def addError(self, txt, **KWS):



        ## CHEETAH: generated from #def addError(txt) at line 16, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        if VFFSL(SL,"varExists",False)('txt'): # generated from line 17, col 1
            self._CHEETAH__globalSetVars["error_text"] = VFFSL(SL,"error_text",True) + '----\n' + VFFSL(SL,"txt",True)
        else: # generated from line 19, col 1
            self._CHEETAH__globalSetVars["error_text"] = VFFSL(SL,"txt",True)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def errorRow(self, value, err, **KWS):



        ## CHEETAH: generated from #def errorRow($value, $err) at line 24, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        if VFFSL(SL,"err",True) and VFFSL(SL,"err.err_field",True) == VFFSL(SL,"value",True): # generated from line 25, col 1
            write('''<tr>
<td class="error" colspan="2">''')
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"err",True)) # '${str($err)}' on line 27, col 31
            if _v is not None: write(_filter(_v, rawExpr='${str($err)}')) # from line 27, col 31.
            write('''</td>
</tr>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''


''')
        _v = VFFSL(SL,"full_body",True) # '$full_body' on line 32, col 1
        if _v is not None: write(_filter(_v, rawExpr='$full_body')) # from line 32, col 1.
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_functions= 'respond'

## END CLASS DEFINITION

if not hasattr(functions, '_initCheetahAttributes'):
    templateAPIClass = getattr(functions, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(functions)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=functions()).run()


